package com.dragoninfo.dcuc.authweb.restcontroller.api.controller;

import com.dragoninfo.dcuc.auth.auth.entity.RoleInfo;
import com.dragoninfo.dcuc.auth.auth.facade.IRoleFacade;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@Controller
@RequestMapping(value = "/rest/authmanage/")
public class RestAuthController {

    @Autowired
    private IRoleFacade roleFacade;

    @RequestMapping(value = "v1/role/{roleId}", method = RequestMethod.GET)
    @ResponseBody
    public RoleInfo role(@PathVariable(value = "roleId") String roleId) {
        return roleFacade.detail(roleId);
    }

    @RequestMapping(value = "v1/roles/{userId}", method = RequestMethod.GET)
    @ResponseBody
    public List<RoleInfo> roles(@PathVariable(value = "userId") String userId) {
        return roleFacade.rolesByUserId(userId);
    }

    @RequestMapping(value = "v1/users/{roleId}", method = RequestMethod.GET)
    @ResponseBody
    public List<String> users(@PathVariable(value = "roleId") String roleId) {
        return roleFacade.getUserIds(roleId);
    }

    @RequestMapping(value = "v1/roles/app/{appId}", method = RequestMethod.GET)
    @ResponseBody
    public List<RoleInfo> rolesbyappid(@PathVariable(value = "appId") String appId) {
        return roleFacade.getRolesByAppId(appId);
    }

    @RequestMapping(value="v1/roles/{userId}/{appCode}",method = RequestMethod.GET)
    @ResponseBody
    public List<RoleInfo> rolesByUserIdAndAppCode(@PathVariable(value = "userId") String userId,@PathVariable(value = "appCode") String appCode){
        return roleFacade.getRolesByUserIdAndAppCode(userId,appCode);
    }



}
