package com.dragoninfo.dcuc.authweb.restcontroller.api.controller;

import com.dragonsoft.duceap.commons.util.string.StringUtils;
import com.google.common.collect.Lists;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.jasig.cas.client.util.XmlUtils;
import org.jasig.cas.client.validation.Assertion;
import org.jasig.cas.client.validation.Cas20ServiceTicketValidator;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 *
 * @author Administrator
 * @date 2019/3/5
 */
@Controller
@RequestMapping(value = "/api/")
public class RestLoginController {
    @RequestMapping(value = "login")
    public void login(@RequestParam(value = "ticket", required = false) String ticket,
                      HttpServletRequest request,
                      HttpServletResponse response) {
        //判断是否是单点登录服务器发出的退出请求
        if (StringUtils.isNotEmpty(request.getParameter("logoutRequest"))) {
            String logoutMessage = request.getParameter("logoutRequest");
            final String key = XmlUtils.getTextForElement(logoutMessage, "SessionIndex");
            //获取key后，从登录时保存的key与登录状态的映射对中获取登录状态并销毁，并处理退出逻辑
            return;
        }
        //验证票据获取用户信息
        if (StringUtils.isEmpty(ticket)) {
            return;
        }
        HttpClient httpclient = HttpClientBuilder.create().build();
        String casTicketValidateUrl = "http://54.179.163.62:8080/dcucserver/serviceValidate";
        URIBuilder uriBuilder = null;
        try {
            uriBuilder = new URIBuilder(casTicketValidateUrl);
            List<NameValuePair> params = Lists.newArrayList();
            params.add(new BasicNameValuePair("ticket", ticket));
            params.add(new BasicNameValuePair("service", "http://172.16.105.196:8888/dcuc/api/login"));
            uriBuilder.addParameters(params);
            HttpGet httpGet = new HttpGet(uriBuilder.build());
            httpGet.addHeader("Content-Type", "application/x-www-form-urlencoded");
            HttpResponse httpResponse = httpclient.execute(httpGet);
            String tokenResponse = EntityUtils.toString(httpResponse.getEntity());
            //解析响应的报文获取用户ID
            Cas20ServiceTicketValidator cas20ServiceTicketValidator = new Cas20ServiceTicketValidator("");
            Assertion assertion = cas20ServiceTicketValidator.parseResponse(tokenResponse);
            String userId = assertion.getPrincipal().getName();
            //获取userId后再调统一用户的相关接口获取更详细的用户信息，并实现系统的登录逻辑
            //再以登录状态（如session）为value，以ticket为key，保存一份key与登录状态的映射对，用于单点退出

            //最后重定向到登录后的页面
            response.sendRedirect(request.getContextPath() + "/index");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
