package com.dragoninfo.dcuc.authweb.restcontroller.auth.vo;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;


@ApiModel(value = "应用功能资源Vo")
@Data
public class AppFunInfoVo {

    @ApiModelProperty(value = "id")
    private String id;

    //功能名称
    @ApiModelProperty(value = "功能名称",required = true)
    private String name;

    //功能代码
    @ApiModelProperty(value = "功能代码",required = true)
    private String code;

    //应用ID
    @ApiModelProperty(value = "应用ID",required = true)
    private String appId;

    //上级功能ID
    @ApiModelProperty(value = "上级功能ID",required = true)
    private String parentId;

    //功能地URL
    @ApiModelProperty(value = "功能地URL",required = true)
    private String url;

    //是否显示
    @ApiModelProperty(value = "是否显示",required = true)
    private String showMode;

    //参数名称(多个以逗号分隔)
    @ApiModelProperty(value = "参数名称(多个以逗号分隔)",required = true)
    private String paramName;

    //默认值
    @ApiModelProperty(value = "默认值",required = true)
    private String paramValue;

    //有效标志(0：无效 1：有效)
    @ApiModelProperty(value = "有效标志(0：无效 1：有效)",required = true)
    private String isActive = "1";

    //排序
    @ApiModelProperty(value = "排序")
    private Integer seq;

    //创建时间
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyyMMdd", timezone = "GMT+8")
    private java.util.Date createTime;

    //创建人
    @ApiModelProperty(value = "创建人",required = true)
    private String creator;

    //修改时间
    @ApiModelProperty(value = "修改时间")
    @JsonFormat(pattern = "yyyyMMdd", timezone = "GMT+8")
    private java.util.Date modifiedTime;

    //修改人
    @ApiModelProperty(value = "修改人",required = true)
    private String modifier;

    //备注
    @ApiModelProperty(value = "备注")
    private String remark;
}
