//package com.dragoninfo.dcuc.authweb.restcontroller.user;
//
//import cn.hutool.core.util.StrUtil;
//import com.dragoninfo.dcuc.app.entity.ApplyInfo;
//import com.dragoninfo.dcuc.app.entity.ManufacturerInfo;
//import com.dragoninfo.dcuc.app.facade.IApplyInfoFacade;
//import com.dragoninfo.dcuc.app.facade.IManufacturerInfoFacade;
//import com.dragoninfo.dcuc.auth.auth.facade.IStaffAssignAuthInfoFacade;
//import com.dragoninfo.dcuc.authweb.common.MtAuthService;
//import com.dragoninfo.dcuc.authweb.common.SysConstants;
//import com.dragoninfo.dcuc.authweb.restcontroller.user.manager.utils.ExportExcelUtils;
//import com.dragoninfo.dcuc.authweb.restcontroller.user.manager.utils.ImpExcelUtils;
//import com.dragoninfo.dcuc.authweb.restcontroller.user.vo.ExternalVo;
//import com.dragoninfo.dcuc.authweb.util.UserUtils;
//import com.dragoninfo.dcuc.duceap.facade.IDuceapUploadFacade;
//import com.dragoninfo.dcuc.duceap.upload.dto.DocContentDTO;
//import com.dragoninfo.dcuc.org.org.entity.OrgInfo;
//import com.dragoninfo.dcuc.org.org.facade.IOrgInfoFacade;
//import com.dragoninfo.dcuc.user.user.entity.UserInfo;
//import com.dragoninfo.dcuc.user.user.enumresources.JobTypeEnum;
//import com.dragoninfo.dcuc.user.user.enumresources.UserTypeEnum;
//import com.dragoninfo.dcuc.user.user.enumresources.YesNotEnum;
//import com.dragoninfo.dcuc.user.user.facade.IAccountInfoFacade;
//import com.dragoninfo.dcuc.user.user.facade.IPostInfoFacade;
//import com.dragoninfo.dcuc.user.user.facade.IUserContactFacade;
//import com.dragoninfo.dcuc.user.user.facade.IUserInfoFacade;
//import com.dragoninfo.duceap.core.enums.ResultEnum;
//import com.dragoninfo.duceap.core.response.Result;
//import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
//import com.dragonsoft.duceap.base.entity.search.SearchDTO;
//import com.dragonsoft.duceap.base.entity.security.SecurityUser;
//import com.dragonsoft.duceap.base.exception.ApplicationException;
//import com.dragonsoft.duceap.commons.util.json.JsonUtils;
//import com.dragonsoft.duceap.core.context.ContextUtils;
//import com.dragonsoft.duceap.core.search.Searchable;
//import com.dragonsoft.duceap.core.search.enums.SearchOperator;
//import com.dragonsoft.duceap.web.controller.BaseController;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiImplicitParam;
//import io.swagger.annotations.ApiOperation;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.data.domain.Page;
//import org.springframework.web.bind.annotation.*;
//
//import javax.annotation.Resource;
//import javax.servlet.http.HttpServletRequest;
//import javax.servlet.http.HttpServletResponse;
//import java.io.ByteArrayInputStream;
//import java.io.IOException;
//import java.io.InputStream;
//import java.math.BigDecimal;
//import java.util.HashMap;
//import java.util.List;
//import java.util.Map;
//
//import static com.dragonsoft.duceap.commons.util.string.StringUtils.isNotEmpty;
//
///**
// * 外部人员Controller
// * Created by yica on 2018/5/24.
// */
//@Api(tags = {"外部人员管理接口"})
//@RestController
//@RequestMapping(value = "/usersvr")
//public class ExternalPersonController extends BaseController {
//
//    private Logger logger = LoggerFactory.getLogger(ExternalPersonController.class);
//
//    @Autowired
//    private IOrgInfoFacade orgInfoFacade;
//    @Autowired
//    private IUserInfoFacade userInfoFacade;
//    @Autowired
//    private IAccountInfoFacade accountInfoFacade;
//    @Autowired
//    private IManufacturerInfoFacade manufacturerInfoFacade;
//    @Autowired
//    private IApplyInfoFacade applyInfoFacade;
//    @Autowired
//    private IStaffAssignAuthInfoFacade staffAssignAuthInfoFacade;
//
//    @Autowired
//    private IPostInfoFacade postInfoFacade;
//
//    @Resource
//    private IDuceapUploadFacade uploadhandler;
//
//    /**
//     * 外部人员查询
//     *
//     * @param searchDTO SearchDTO
//     * @return Result
//     */
//    @ApiOperation(value = "外部人员查询")
//    @ApiImplicitParam(name = "SearchDTO", value = "查询条件")
//    @PostMapping(value = "/externals")
//    public Result auxiliryPage(SearchDTO searchDTO) {
//        Searchable searchable = Searchable.toSearchable(searchDTO);
//        searchable.addSearchFilter("deleted", SearchOperator.eq, "0");
//        searchable.addSearchFilter("userType", SearchOperator.eq, UserTypeEnum.EXTERNAL.getValue());
//        if (!searchDTO.getSearchCondition().contains("userStatus")) {
//            searchable.addSearchFilter("userStatus", SearchOperator.ne, "0");
//        }
//        Page<UserInfo> page = userInfoFacade.userList(searchable.toSearchDTO());
//        page.getContent().stream().forEach(this::accept);
//        return Result.success(page.getTotalElements(), page.getContent());
//    }
//
//    /**
//     * 公司名称
//     *
//     * @param userInfo 设置公司名称
//     */
//    private void accept(UserInfo userInfo) {
//        if (isNotEmpty(userInfo.getCompany())) {
//            ManufacturerInfo m = manufacturerInfoFacade.manufacturerInfoDetail(userInfo.getCompany());
//            if (m != null) {
//                userInfo.setCompany(m.getManufacturerName());//公司名称
//            }
//        }
//        if (isNotEmpty(userInfo.getProject())) {
//            userInfo.setProject(applyInfoFacade.convertIdsToNames(userInfo.getProject()));
//        }
//    }
//
//    @ApiOperation(value = "外部人员保存")
//    @PostMapping(value = "/external")
//    public Result save(@RequestBody ExternalVo vo) {
//        try {
//            UserInfo info = new UserInfo();
//            UserUtils.copyObject(info, vo);
//            //姓名不能为ADMIN
//            if (UserUtils.verificaName(info)) {
//                return Result.fail(ResultEnum.FAIL.getKey(), "姓名不能为ADMIN");
//            }
//            //判断是否重复
//            ResponseStatus responseStatus = userInfoFacade.checkUserNotRepeat(info);
//            if (!ResponseStatus.SUCCESS_CODE.equals(responseStatus.getStatusCode())) {
//                return Result.fail(ResultEnum.FAIL.getKey(), responseStatus.getMessage());
//            }
//            //如果由警员转为施工人员则删除职位
//            if (UserTypeEnum.POLICE.equals(info.getUserType())) {
//                postInfoFacade.del(info.getId());
//            }
//            setUser(info);
//            userInfoFacade.saveOrUpdateAuxiliry(info);
//            return Result.success();
//        } catch (Exception e) {
//            logger.error("保存失败", e);
//            return Result.fail(ResultEnum.FAIL.getKey(), "保存失败");
//        }
//    }
//
//
//    @ApiOperation(value = "外部人员修改")
//    @PutMapping(value = "/external/{id}")
//    public Result update(@RequestBody ExternalVo vo) {
//        try {
//            UserInfo info = new UserInfo();
//            UserUtils.copyObject(info, vo);
//            //姓名不能为ADMIN
//            if (UserUtils.verificaName(info)) {
//                return Result.fail(ResultEnum.FAIL.getKey(), "姓名不能为ADMIN");
//            }
//            //判断是否重复
//            ResponseStatus responseStatus = userInfoFacade.checkUserNotRepeat(info);
//            if (!ResponseStatus.SUCCESS_CODE.equals(responseStatus.getStatusCode())) {
//                return Result.fail(ResultEnum.FAIL.getKey(), responseStatus.getMessage());
//            }
//            //如果由警员转为施工人员则删除职位
//            if (UserTypeEnum.POLICE.equals(info.getUserType())) {
//                postInfoFacade.del(info.getId());
//            }
//            //放入一些必要的参数
//            setUser(info);
//            userInfoFacade.saveOrUpdateAuxiliry(info);
//            return Result.success();
//        } catch (Exception e) {
//            logger.error("保存失败", e);
//            return Result.fail(ResultEnum.FAIL.getKey(), "保存失败");
//        }
//    }
//
//    public void setUser(UserInfo info) {
//        String[] projects = (info.getProject() == null ? "" : info.getProject()).split(",");
//        ApplyInfo applyInfo = applyInfoFacade.applyDetail(projects[0]);
//        OrgInfo orgInfo = orgInfoFacade.detail(applyInfo == null ? "" : applyInfo.getOrgId());
//        info.setOrgId(orgInfo == null ? "" : orgInfo.getId());
//        info.setOrgName(orgInfo == null ? "" : orgInfo.getFullName());
//        info.setOrgCode(orgInfo == null ? "" : orgInfo.getCode());
//        info.setOrgLevel(orgInfo == null ? "" : orgInfo.getOrgLevel());
//        info.setDeleted("0");
//        info.setBirth(isNotEmpty(info.getBirth()) ? info.getBirth().replaceAll("-", "") : "");
//        info.setUserType(UserTypeEnum.EXTERNAL.getValue());
//    }
//
//    @ApiOperation(value = "获取外部人员")
//    @ApiImplicitParam(name = "id", value = "id", required = true)
//    @GetMapping(value = "/external/{id}")
//    public Result<ExternalVo> detail(@PathVariable("id") String id) {
//        SecurityUser securityUser = (SecurityUser) ContextUtils.getUserInfo();
//        UserInfo userInfo = new UserInfo();
//        ExternalVo externalVo = new ExternalVo();
//        userInfo = userInfoFacade.userDetail(id);
//        String project = userInfo.getProject();
//        String company = userInfo.getCompany();
//
//        this.accept(userInfo);
//        // this.accept(userInfo);
//        //manufacturerInfo = manufacturerInfoFacade.manufacturerInfoDetail(userInfo.getCompany());
//        UserUtils.copyObject(externalVo, userInfo);
//        externalVo.setCreateTime(UserUtils.transformDate(userInfo.getCreateTime()));
//        externalVo.setBirth(UserUtils.birthTransform(userInfo.getBirth(), "8"));
//        externalVo.setProjectName(externalVo.getProject());
//        externalVo.setProject(project);
//        externalVo.setCompany(company);
//        externalVo.setFileHolders(uploadhandler.queryByBusiId(id, ""));
//        //Map map=new HashMap();
//        // map.put("model", externalVo);
//        // map.put("manufacturerInfo", manufacturerInfo);
//        //  map.put("manage", manage);
//        return Result.success(externalVo);
//    }
//
//    @ApiOperation(value = "获取警号和排序号")
//    @GetMapping(value = "/external/number")
//    public Result getNumber() {
//        try {
//            Map map = new HashMap();
//            String policeNumber = userInfoFacade.policeNumber(UserTypeEnum.EXTERNAL.getValue());
//            int pn = Integer.valueOf(policeNumber.substring(2)) + 1;
//            BigDecimal num = new BigDecimal(1);
//            BigDecimal sort = userInfoFacade.sortNew(UserTypeEnum.EXTERNAL.getValue()).add(num);
//            map.put("policeNumber", "WB" + String.format("%06d", pn));
//            map.put("sortNo", sort);
//            return Result.success(map);
//        } catch (Exception e) {
//            logger.error("获取失败", e);
//            return Result.fail("300", "获取失败");
//        }
//    }
////
////
////    @ApiOperation(value = "外部人员详情")
////    @ApiImplicitParam(name="id",value="id",required=true)
////    @GetMapping(value = "detail")
////    public Result<ResultData> detail(@RequestParam("id") String id) {
//////        String type = request.getParameter("type");
////        UserInfo userInfo = new UserInfo();
////        userInfo = userInfoFacade.userDetail(id);
////        if (isNotEmpty(userInfo.getCompany())) {
////            ManufacturerInfo m = manufacturerInfoFacade.manufacturerInfoDetail(userInfo.getCompany());
////            if (m != null) {
////                userInfo.setCompany(m.getManufacturerName());
////                userInfo.setCompanyPerson(m.getName());
////                userInfo.setPersonMobile(m.getPhone());
////            }
////        }
//////        if (isNotEmpty(type) && "search".equals(type)) {
//////            boolean enable = userListFacade.isEnable(UserUtils.getSysUserListId());
//////            if (enable) {
//////                String userIds = userListFacade.userListDetailListStrByListId(UserUtils.getSysUserListId());
//////                userInfo = UserUtils.objectHandler(userInfo, userIds);
//////            }
//////            model.addAttribute("type", type);
//////        }
////        if (isNotEmpty(userInfo.getProject())) {
////            userInfo.setProject(iApplyInfoFacade.convertIdsToNames(userInfo.getProject()));
////        }
////        if (isNotEmpty(userInfo.getDutyProject())) {
////            userInfo.setDutyProject(iApplyInfoFacade.convertIdsToNames(userInfo.getDutyProject()));
////        }
////        Map map=new HashMap();
////        ExternalVo externalVo=new ExternalVo();
////        UserUtils.copyObject(externalVo,userInfo);
////        ResultData data=new ResultData();
////        data.setModel(externalVo);
////        //map.put("model", externalVo);
////       return Result.success(data);
////    }
//
//
////    @PostMapping(value = "getInfo")
////    public AccountInfo getInfo(Model model) {
////        AccountInfo accountInfo = new AccountInfo();
////        model.addAttribute("model", accountInfo);
////        return accountInfo;
////    }
//
//    /**
//     * 导出外部人员
//     *
//     * @param request
//     */
//    @ApiOperation(value = "外部人员导出")
//    @ApiImplicitParam(name = "SearchDTO", value = "查询条件")
//    @PostMapping(value = "/external/exports")
//    public void listExport(SearchDTO searchDTO, HttpServletRequest request, HttpServletResponse response) {
//        try {
//            searchDTO.setMetadata(this.template());
//            Searchable searchable = Searchable.toSearchable(searchDTO);
//            searchable.addSearchFilter("userType", SearchOperator.eq, UserTypeEnum.EXTERNAL.getValue());
//            searchable.addSearchFilter("deleted", SearchOperator.eq, YesNotEnum.NO.getValue());
//            searchable.addSearchFilter("jobType", SearchOperator.notIn, JobTypeEnum.LZ.getValue());
//            searchDTO = searchable.toSearchDTO();
//            searchDTO.setSize(String.valueOf(SysConstants.EXPORT_NUMBER_MAX));
//            List<UserInfo> lists = userInfoFacade.userList(searchDTO).getContent();
//            if (lists.size() > 0) {
//                Map map = new HashMap();
//                map.put("deleted", "0");
//
//                Map<String, String> allIdNameMap = manufacturerInfoFacade.getAllIdNameMap();
//                Map<String, String> appAllIdNameMap = applyInfoFacade.getAllIdNameMap();
//                for (UserInfo u : lists) {
//                    if (isNotEmpty(u.getCompany())) {
//                        String manufacturerInfoName = allIdNameMap.getOrDefault(u.getCompany(), "");
//                        if (StrUtil.isNotBlank(manufacturerInfoName)) {
//                            //公司名称
//                            u.setCompany(manufacturerInfoName);
//                        }
//                    }
//                    if (isNotEmpty(u.getProject())) {
//                        String projects = u.getProject();
//                        String[] projectArray = projects.split(",");
//                        StringBuilder applyNameBuilder = new StringBuilder();
//                        for (String project : projectArray) {
//                            String projectApplyName = appAllIdNameMap.put(project, "");
//                            if (StrUtil.isNotBlank(projectApplyName)) {
//                                applyNameBuilder.append(projectApplyName).append(",");
//                            }
//                        }
//                        if (applyNameBuilder.length() > 0) {
//                            applyNameBuilder = new StringBuilder(applyNameBuilder.substring(0, applyNameBuilder.length() - 1));
//                        }
//                        u.setProject(applyNameBuilder.toString());
//                    }
//                }
//            }
//
//            ExportExcelUtils.exportExternal("外部人员", lists, searchable.getMetaData(), request, response);
//        } catch (Exception e) {
//            throw new ApplicationException(300, "导出失败", e);
//        }
//
//    }
//
//
//    @ApiOperation(value = "外部人员删除")
//    @ApiImplicitParam(name = "id", value = "id", required = true)
//    @DeleteMapping(value = "external/{id}")
//    public Result del(@PathVariable("id") String id) {
//        try {
//            userInfoFacade.deleteUser(id);
//            accountInfoFacade.del(id);
//            //删除角色授权
//            staffAssignAuthInfoFacade.deleteAllStaffRole(id);
//            return Result.success();
//        } catch (Exception e) {
//            logger.error("删除失败", e);
//            return Result.fail(ResultEnum.FAIL.getKey(), "删除失败");
//        }
//    }
//
//    @PostMapping(value = "external/import")
//    @ApiImplicitParam(name = "fileId", value = "导入文件id")
//    @ApiOperation(value = "外部人员导入")
//    public Result impExcel(@RequestBody String fileId) {
//        try {
//            fileId = JsonUtils.parseObject(fileId).getString("fileId");
//            DocContentDTO fileContent = uploadhandler.getFileContent(fileId);
//            byte[] fileData = fileContent.getFileData();
//            InputStream inputStream = new ByteArrayInputStream(fileData);
//            List<UserInfo> list = ImpExcelUtils.loadScoreInfo(inputStream, UserTypeEnum.EXTERNAL.getValue());
//            String message = this.impExternalPerson(list);
//            if (message != null) {
//                if (message.startsWith("身份证或编号重复，未保存人员")) {
//                    throw new NumberFormatException(message);
//                }
//            }
//            return Result.success("导入成功");
//        } catch (IOException e) {
//            logger.error(e.getMessage(), e);
//            return Result.fail("300", "导入文件类型错误");
//        } catch (NumberFormatException e) {
//            return Result.fail("300", e.getMessage());
//        } catch (Exception e) {
//            logger.error(e.getMessage(), e);
//            return Result.fail("300", "导入失败");
//        }
//    }
//
//    public String impExternalPerson(List<UserInfo> list) {
//        BigDecimal num = new BigDecimal(1);
//        BigDecimal sort = userInfoFacade.sortNew(UserTypeEnum.EXTERNAL.getValue()).add(num);
//        Map<String, ApplyInfo> appMap = getAppMap();
//        for (UserInfo info : list) {
//            info.setSortNo(sort);
//            String[] projects = (info.getProject() == null ? "" : info.getProject()).split(",");
//            //默认机构
//            ApplyInfo applyInfo = appMap.get(projects[0]);
//            OrgInfo orgInfo = orgInfoFacade.detail(applyInfo == null ? "" : applyInfo.getOrgId());
//            info.setOrgId(orgInfo == null ? "" : orgInfo.getId());
//            info.setOrgName(orgInfo == null ? "" : orgInfo.getFullName());
//            info.setOrgCode(orgInfo == null ? "" : orgInfo.getCode());
//            info.setOrgLevel(orgInfo == null ? "" : orgInfo.getOrgLevel());
//            info.setCompany(applyInfo == null ? "" : applyInfo.getManufacturerId());
//            //项目code替换为项目id
//            StringBuffer appIds = new StringBuffer();
//            for (String code : projects) {
//                ApplyInfo apply = appMap.get(code);
//                appIds.append(apply == null ? "" : (apply.getId() + ","));
//            }
//            info.setProject(appIds.length() > 0 ? appIds.substring(0, appIds.length() - 1) : "");
//            sort = sort.add(num);
//        }
//        return userInfoFacade.impAuxiliry(list);
//    }
//
//    public Map<String, ApplyInfo> getAppMap() {
//
//        List<ApplyInfo> applyInfoList = applyInfoFacade.getAllList();//所有应用
//        Map<String, ApplyInfo> appMap = new HashMap<String, ApplyInfo>();//应用code，机构id
//        for (ApplyInfo applyInfo : applyInfoList) {
//            appMap.put(applyInfo.getApplyCode(), applyInfo);
//        }
//        return appMap;
//    }
//
////    @ApiOperation(value = "根据厂商ID，获取厂商所有的应用")
////    @ApiImplicitParam(value = "mfrId" ,name = "厂商Id",required = true)
////    @PostMapping(value = "manuPersons")
////    public Result manuPersons(@RequestBody String mfrId) {
////        List<Map<String, String>> list = new ArrayList<Map<String, String>>();
////        if (isEmpty(mfrId))
////            return Result.success(list);
////        List<UserInfo> userList = userInfoFacade.manuPersons(mfrId);
////        for (UserInfo user : userList) {
////            Map<String, String> appmap = new HashMap<String, String>();
////            appmap.put("code", user.getId());
////            appmap.put("value", user.getName());
////            list.add(appmap);
////        }
////        return Result.success(list);
////    }
//
////    @ApiOperation(value = "根据通讯类型，用户ID,获取通讯详情")
////    @PostMapping({"userContact"})
////    public Result manuPersons(@RequestBody Map<String,String> map) {
////        String type = map.get("type");
////        String userId = map.get("userId");
////        if (isEmpty(type) || isEmpty(userId)) {
////            return Result.success();
////        }
////        UserContact contact = iUserContactFacade.detail(userId, type);
////        return Result.success(contact);
////    }
//
//    /**
//     * 模板
//     *
//     * @return
//     */
//    private String template() {
//        return "[{\"name\":\"name\",\"displyName\":\"姓名\"}," +
//                "{\"name\":\"policeNumber\",\"displyName\":\"编号\"}," +
//                "{\"name\":\"idcard\",\"displyName\":\"身份证\"}," +
//                "{\"name\":\"company\",\"displyName\":\"公司名称\"}," +
//                "{\"name\":\"project\",\"displyName\":\"施工项目\"}," +
//                "]";
//    }
//
//
//}
