package com.dragoninfo.dcuc.authweb.restcontroller.user;

import com.dragoninfo.dcuc.user.admin.entity.MgeMonitorMsg;
import com.dragoninfo.dcuc.user.admin.facade.IMgeMonitorFacade;
import com.dragoninfo.dcuc.user.user.facade.IUserInfoFacade;
import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
import com.dragonsoft.duceap.base.entity.search.SearchDTO;
import com.dragonsoft.duceap.base.entity.security.SecurityUser;
import com.dragonsoft.duceap.core.context.ContextUtils;
import com.dragonsoft.duceap.core.entity.page.PageImpl;
import com.dragonsoft.duceap.core.entity.response.ResponseResult;
import com.dragonsoft.duceap.core.search.Searchable;
import com.dragonsoft.duceap.web.controller.BaseController;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

@Controller
@RequestMapping(value = "/messages/")
public class MgeMonitorMsgController extends BaseController {

    @Autowired
    private IMgeMonitorFacade iMgeMonitorFacade;
    @Autowired
    private IUserInfoFacade userInfoFacade;

    @RequestMapping(value = "mgeList")
    @ResponseBody
    public ResponseResult messageList(Searchable searchable) {
        SearchDTO searchDTO = searchable.toSearchDTO();
        SecurityUser user = (SecurityUser) ContextUtils.getUserInfo();
        Page<MgeMonitorMsg> messagesPage = new PageImpl<MgeMonitorMsg>();
        if (userInfoFacade.getRootUser().equals(user.getUserName())) {
            messagesPage = iMgeMonitorFacade.allMessage(searchDTO);
        } else {
            messagesPage = iMgeMonitorFacade.messageList(user.getId(), searchDTO);
        }
        if (messagesPage.getContent() != null) {
            for (MgeMonitorMsg message : messagesPage.getContent()) {
                //对长时间未登录管理员暂时不进行删除,仅停用账号
/*                if (message.getAbnormalType().equals(AbnormalTypeEnum.TY.getCode())) {
                    message.setAbnormalType("超过未登录期限天数，账号已停用");
                } else {*/
                Date laster = message.getLastLoginTime();
                Date nowdate = new Date();
                int leveDate = (int) ((nowdate.getTime() - laster.getTime()) / (1000 * 3600 * 24));
                message.setAbnormalType(leveDate + "天未登陆");
//                }
            }
        }
        return ResponseResult.newInstance(messagesPage);
    }

    @RequestMapping(value = "messageListByOrg")
    @ResponseBody
    public ResponseResult messageListByOrg(Searchable searchable) {
        SearchDTO searchDTO = searchable.toSearchDTO();
        SecurityUser user = (SecurityUser) ContextUtils.getUserInfo();
        String userId = user.getId();
        Page<MgeMonitorMsg> messagesPage = iMgeMonitorFacade.messageListByOrg(userId, searchDTO);
        if (messagesPage.getContent() != null) {
            //对长时间未登录管理员暂时不进行删除，仅停用账号
            for (MgeMonitorMsg message : messagesPage.getContent()) {
/*                if (message.getAbnormalType().equals(AbnormalTypeEnum.TY.getCode())) {
                    message.setAbnormalType("超过未登录期限天数，账号已停用");
                } else {*/
                Date laster = message.getLastLoginTime();
                Date nowdate = new Date();
                int leveDate = (int) ((nowdate.getTime() - laster.getTime()) / (1000 * 3600 * 24));
                message.setAbnormalType(leveDate + "天未登陆");
//                }
            }
        }
        return ResponseResult.newInstance(messagesPage);
    }

    @RequestMapping(value = "delete")
    @ResponseBody
    public ResponseStatus delete(String mgeId) {
        if (StringUtils.isEmpty(mgeId)) {
            return ResponseStatus.fail("请选择要删除的提醒！");
        }
        iMgeMonitorFacade.deletedMsgById(mgeId);
        return ResponseStatus.success("删除成功！");
    }
}