package com.dragoninfo.dcuc.authweb.restcontroller.user;

import com.dragoninfo.dcuc.user.user.entity.UserInfo;
import com.dragoninfo.dcuc.user.user.facade.IUserInfoFacade;
import com.dragoninfo.duceap.core.response.Result;
import com.dragonsoft.duceap.base.entity.search.SearchDTO;
import com.dragonsoft.duceap.core.context.ContextUtils;
import com.dragonsoft.duceap.core.search.Searchable;
import com.dragonsoft.duceap.core.search.enums.SearchOperator;
import com.dragonsoft.duceap.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "用户综合查询接口")
@RestController
@RequestMapping(value = "/usersvr/synthentical")
public class UserSyntheticalController extends BaseController {
    @Autowired
    private IUserInfoFacade userInfoFacade;

    @ApiOperation(value = "查询审计报表人员列表")
    @ApiImplicitParam(name = "SearchDTO", value = "查询条件")
    @PostMapping(value = "/users")
    public Result auditRptUserInfoPage(SearchDTO searchDTO){
        Searchable searchable = Searchable.toSearchable(searchDTO);
        if(searchDTO.getSearchCondition().equals("[]")){
            UserInfo userInfo = userInfoFacade.get(ContextUtils.getUserInfo().getId());
            searchable.addSearchFilter("orgId", SearchOperator.eq, userInfo.getOrgId());
        }
        searchable.addSearchFilter("userType",SearchOperator.ne,"30");
        searchDTO = searchable.toSearchDTO();
        Page<UserInfo> page = userInfoFacade.userListRpt(searchDTO);
        return Result.success(page.getTotalElements(), page.getContent());
    }
}
