package com.dragoninfo.dcuc.authweb.restcontroller.user.manager.utils;


import com.dragoninfo.dcuc.user.admin.entity.MonitorFeedback;
import com.dragoninfo.dcuc.user.user.entity.UserInfo;
import com.dragoninfo.dcuc.user.user.entity.UserInfoView;
import com.dragonsoft.duceap.base.entity.metadata.MetaData;
import com.dragonsoft.duceap.base.entity.metadata.MetaDataType;
import com.dragonsoft.duceap.commons.util.string.StringUtils;
import com.dragonsoft.duceap.core.convert.Converter;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.springframework.boot.system.ApplicationHome;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.Iterator;
import java.util.List;

/**
 * Created by Administrator on 2019/11/27.
 */
public class ExportExcelUtils {

    public static void exportPoliceExcel(String fileName, List<UserInfoView> result, List<? extends MetaData> columns, HttpServletRequest request, HttpServletResponse response) {
        exportExcel(fileName, result, columns, request, response, "/template/ExportPolice.xls");
    }

    public static void batchExportAuxiliarypolice(String fileName, List<UserInfoView> result, List<? extends MetaData> columns, HttpServletRequest request, HttpServletResponse response) {
        exportExcel(fileName, result, columns, request, response, "/template/ExportAuxiliarypolice.xls");
    }

    public static void exportAuxiliarypolice(String fileName, List<UserInfo> result, List<? extends MetaData> columns, HttpServletRequest request, HttpServletResponse response) {
        exportExcel(fileName, result, columns, request, response, "/template/ExportAuxiliarypolice.xls");
    }

    public static void exportAdminExcel(String fileName, List<UserInfo> result, List<? extends MetaData> columns, HttpServletRequest request, HttpServletResponse response) {
        exportExcel(fileName, result, columns, request, response, "/template/ExportAdmin.xls");
    }

    public static void exportFeedbackExcel(String fileName, List<MonitorFeedback> result, List<? extends MetaData> columns, HttpServletRequest request, HttpServletResponse response) {
        exportExcel(fileName, result, columns, request, response, "/template/ExportFeedback.xls");
    }

    public static void exportExternal(String fileName, List<UserInfo> result, List<MetaData> columns, HttpServletRequest request, HttpServletResponse response) {
        exportExcel(fileName, result, columns, request, response, "/template/ExportExternal.xls");
    }

    public static void exportExcel(String fileName, List<?> result, List<? extends MetaData> columns, HttpServletRequest request, HttpServletResponse response, String path) {
        ApplicationHome home = new ApplicationHome(ExportExcelUtils.class);
        File sysfile = home.getSource();
        String jarPath = sysfile.getPath();//classes路径
        OutputStream outputStream = null;
        InputStream inputStream = null;
        try {
            Resource resource = new ClassPathResource(path);
            inputStream = resource.getInputStream();
            HSSFWorkbook hssfWorkbook = new HSSFWorkbook(inputStream);
            HSSFSheet hssfSheet = hssfWorkbook.getSheetAt(0);
            int rowNum = 0;
            for (Object object : result) {
                ++rowNum;
                HSSFRow row = hssfSheet.createRow(rowNum);
                Iterator iterator = columns.iterator();
                int columnIndex = 0;
                while (iterator.hasNext()) {
                    MetaData metaField = (MetaData) iterator.next();
                    if (StringUtils.isEmpty(metaField.getType()))
                        metaField.setType(MetaDataType.CHAR.name());
                    Object value = Converter.getInstance().convertProperty(object, metaField);
                    String valuestr = null;
                    if (value != null) {
                        valuestr = value.toString();
                    }

                    HSSFCell cell = row.createCell(columnIndex);
                    cell.setCellValue(valuestr);
                    ++columnIndex;
                }
            }
            response.setHeader("Cache-Control", "private");
            response.setHeader("Pragma", "private");
            response.setContentType("application/vnd.ms-excel;charset=utf-8");
            String codedfilename = decodeFileName(fileName, request, response);
            response.setHeader("Content-disposition", "attachment; filename=" + codedfilename + ".xls");
            outputStream = new BufferedOutputStream(response.getOutputStream());
            hssfWorkbook.write(outputStream);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (outputStream != null) {
                try {
                    outputStream.flush();
                    outputStream.close();
                } catch (Exception var17) {
                    var17.printStackTrace();
                }
            }
        }
    }

//    public static void exportAuxiExcel(String fileName, List<UserInfo> result, List<? extends MetaData> columns, HttpServletRequest request, HttpServletResponse response) {
//        ApplicationHome home = new ApplicationHome(ExportExcelUtils.class);
//        File sysfile = home.getSource();
//        String jarPath = sysfile.getPath();//classes路径
//        OutputStream outputStream = null;
//        String path = "/template/ExportAuxiliarypolice.xls";
//        try {
//            File file = new File(jarPath + path);
//            InputStream inputStream = new FileInputStream(file);
//            HSSFWorkbook hssfWorkbook = new HSSFWorkbook(inputStream);
//            HSSFSheet hssfSheet = hssfWorkbook.getSheetAt(0);
//            int rowNum = 0;
//            for (UserInfo userInfo : result) {
//                ++rowNum;
//                HSSFRow row = hssfSheet.createRow(rowNum);
//                Iterator iterator = columns.iterator();
//                int columnIndex = 0;
//                while (iterator.hasNext()) {
//                    MetaData metaField = (MetaData) iterator.next();
//                    metaField.setType(MetaDataType.CHAR.name());
//                    Object value = Converter.getInstance().convertProperty(userInfo, metaField);
//                    String valuestr = null;
//                    if (value != null) {
//                        valuestr = value.toString();
//                    }
//
//                    HSSFCell cell = row.createCell(columnIndex);
//                    cell.setCellValue(valuestr);
//                    ++columnIndex;
//                }
//            }
//            response.setHeader("Cache-Control", "private");
//            response.setHeader("Pragma", "private");
//            response.setContentType("application/vnd.ms-excel;charset=utf-8");
//            String codedfilename = decodeFileName(fileName, request, response);
//            response.setHeader("Content-disposition", "attachment; filename=" + codedfilename + ".xls");
//            outputStream = new BufferedOutputStream(response.getOutputStream());
//            hssfWorkbook.write(outputStream);
//        } catch (Exception e) {
//            e.printStackTrace();
//        } finally {
//            if (outputStream != null) {
//                try {
//                    outputStream.flush();
//                    outputStream.close();
//                } catch (Exception var17) {
//                    var17.printStackTrace();
//                }
//            }
//
//        }
//    }

    public static String decodeFileName(String fileName, HttpServletRequest request, HttpServletResponse response) throws UnsupportedEncodingException {
        String codedfilename = null;
        String agent = request.getHeader("USER-AGENT");
        if ((null == agent || -1 == agent.indexOf("MSIE")) && (null == agent || -1 == agent.indexOf("Trident"))) {
            if (null != agent && -1 != agent.indexOf("Mozilla")) {
                fileName = URLDecoder.decode(fileName, "UTF-8");
                codedfilename = new String(fileName.getBytes(StandardCharsets.UTF_8), StandardCharsets.ISO_8859_1);
            }
        } else {
            codedfilename = URLEncoder.encode(fileName, "UTF-8");
        }
        return codedfilename;
    }


}
