package com.dragoninfo.dcuc.authweb.restcontroller.user.vo;

import com.dragonsoft.duceap.base.entity.uploader.FileHolder;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * Created by yica on 2020/4/17.
 */
@Data
@ApiModel(value = "辅警vo")
public class AuxiliryVo {

    @ApiModelProperty(value = "用户ID")
    private String id;


    @ApiModelProperty(value = "姓名")
    private String name;

    @ApiModelProperty(value = "身份证",required=true)
    private String idcard;

    @ApiModelProperty(value = "民族")
    private String nation;

    @ApiModelProperty(value = "性别",required=true)
    private String sex;

    @ApiModelProperty(value = "出生日期",required=true)
    private String birth;


    @ApiModelProperty(value = "所在机构编码")
    private String orgCode;


    //orgId
    @ApiModelProperty(value = "所在机构ID",required=true)
    private String orgId;

    //orgId
    @ApiModelProperty(value = "所在机构名称",required=true)
    private String orgName;

    @ApiModelProperty(value = "联系地址")
    private String address;


    //人员身份类型10：民警 15：现役特警 20：辅警 25：外部党政人员 30：在编文员  99999：其他工勤人员
    @ApiModelProperty(value = "人员身份类型",required=true)
    private String manType;

    @ApiModelProperty(value = "警衔",required=true)
    private String rank;

    @ApiModelProperty(value = "职级")
    private String title;

    @ApiModelProperty(value = "警种")
    private String policeCategory;

    @ApiModelProperty(value = "业务域")
    private String policeBusiness;
    //警号
    @ApiModelProperty(value = "警号")
    private String policeNumber;
    //所属公司

    @ApiModelProperty(value = "手机号码（私人号）",required = true)
    private String mobilePrivate;
    @ApiModelProperty(value = "手机号码（工作号）")
    private String mobileWork;
    @ApiModelProperty(value = "电话")
    private String phone;
    @ApiModelProperty(value = "qq号")
    private String qqAccount;
    @ApiModelProperty(value = "邮箱")
    private String email;
    @ApiModelProperty(value = "微信号")
    private String wxAccount;
    @ApiModelProperty(value = "密码")
    private String password;

    @ApiModelProperty(value = "省份")
    private String area;

    @ApiModelProperty(value = "人员状态")
    private String userStatus="1";

    @ApiModelProperty(value = "图片ID")
    private String photo;
    @ApiModelProperty(value = "创建时间")
    private String createTime;

    @ApiModelProperty(value = "排序号",required=true)
    private String sortNo;

    @ApiModelProperty(value = "职务表")
    private List<PostInfoVo> postInfos;

    @ApiModelProperty(value = "辅警类型 （10：合同工、20：聘用、30：其它）")
    private String auxiliaryType;

    @ApiModelProperty(value = "附件")
    private List<FileHolder> file;
}
