package com.dragoninfo.dcuc.authweb.restcontroller.user.vo;

import com.dragoninfo.dcuc.user.user.entity.PostInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * Created by yica on 2020/4/17.
 */
@Data
@ApiModel(value = "职务vo")
public class PostInfoVo {

    private String id;

    //警员ID
    @ApiModelProperty(value = "警员ID")
    private String userId;

    //机构ID
    @ApiModelProperty(value = "机构ID")
    private String orgId;

    //机构名称
    @ApiModelProperty(value = "机构名称")
    private String orgName;

    //机构代码
    @ApiModelProperty(value = "机构代码", required = true)
    private String orgCode;

    //职务
    @ApiModelProperty(value = "职务", required = true)
    private String postType;

    //在职类型（11：在职  12：兼职  13：挂职  14：返聘）
    @ApiModelProperty(value = "在职类型", required = true)
    private String jobType;

    //入职日期
    @ApiModelProperty(value = "入职日期")
    private Date startDate;

    //离职日期
    @ApiModelProperty(value = "离职日期")
    private Date overDate;


    @ApiModelProperty(value = "排序号")
    private String sortNo;

    @ApiModelProperty(value = "类型")
    private String type;

    public PostInfo getPostInfo() {
        PostInfo postInfo = new PostInfo();
        postInfo.setId(this.id);
        postInfo.setUserId(this.userId);
        postInfo.setOrgId(this.orgId);
        postInfo.setOrgName(this.orgName);
        postInfo.setOrgCode(this.orgCode);
        postInfo.setPostType(this.postType);
        postInfo.setJobType(this.jobType);
        postInfo.setStartDate(this.startDate);
        postInfo.setOverDate(this.overDate);
        postInfo.setSortNo(new BigDecimal(this.sortNo));
        postInfo.setType(this.type);
        return postInfo;
    }
}
