package com.dragoninfo.dcuc.authweb.restcontroller.user.vo;

import com.dragonsoft.duceap.base.entity.uploader.FileHolder;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;


/**
 * Created by Fuzq on 2020/5/10.
 */
@Data
public class UserVo {



	//编号
    @ApiModelProperty(value = "编号")
	private String id;

	//姓名
    @ApiModelProperty(value = "姓名")
	private String name;

	//身份证
    @ApiModelProperty(value = "身份证")
	private String idcard;

	//民族
    @ApiModelProperty(value = "民族")
	private String nation;

	//性别 10：男 20：女 99999：未知
    @ApiModelProperty(value = "性别")
	private String sex;

	//出生日期
	@JsonFormat(pattern = "yyyy-MM-dd",timezone="GMT+8")
    @ApiModelProperty(value = "出生日期")
	private String birth;

	//用户类型：10 民警  20 辅警    30外部人员
	@ApiModelProperty(value = "用户类型：10 民警  20 辅警    30外部人员")
	private String userType;

	//照片
    @ApiModelProperty(value = "照片")
	private String photo;


	//人员身份类型10：民警 15：现役特警 25：在编文员  25：外部党政人员
    @ApiModelProperty(value = "人员身份类型10")
	private String manType;


	//警衔
    @ApiModelProperty(value = "警衔")
	private String rank;

	//联系地址
	@ApiModelProperty(value = "联系地址")
	private String address;

	//警种
    @ApiModelProperty(value = "警种")
	private String policeCategory;

	//职级，引用表码
	@ApiModelProperty(value = "职级")
	private String title;

	//业务域编号
    @ApiModelProperty(value = "业务域编号")
	private String policeBusiness;

	@ApiModelProperty(value = "账号名称")
	private String accountName;

	@ApiModelProperty(value = "密码")
	private String password;


	@ApiModelProperty(value = "政务微信手机号")
	private String mobileWork;

	@ApiModelProperty(value = "手机号码")
	private String mobilePrivate;

	@ApiModelProperty(value = "座机")
	private String phone;

	@ApiModelProperty(value = "邮箱")
	private String email;


	@ApiModelProperty(value = "职务表")
    private List<PostInfoVo> postInfos;


    @ApiModelProperty(value = "附件")
    private List<FileHolder> file;

	//警号
	@ApiModelProperty(value = "警号")
	private String policeNumber;

	@ApiModelProperty(value = "所在机构id")
	private String orgId;

	@ApiModelProperty(value = "所在机构编码")
	private String orgCode;

	@ApiModelProperty(value = "所在机构名称")
	private String orgName;

	@ApiModelProperty(value = "管理员id")
	private String adminId;
	//管理员名称
	@ApiModelProperty(value = "管理员姓名")
	private String adminName;
	//管理员手机号
	@ApiModelProperty(value = "管理员电话")
	private String adminPhone;
	@ApiModelProperty(value = "省份")
	private String area;
	@ApiModelProperty(value = "qq号")
	private String qqAccount;
	@ApiModelProperty(value = "wx号")
	private String wxAccount;
	@ApiModelProperty(value = "多维审核状态")
	private String regStatus;
	@ApiModelProperty(value = "单位变更审核状态")
	private String moveStatus;
	@ApiModelProperty(value = "借调申请审核状态")
	private String loanStatus;
	@ApiModelProperty(value = "单位变更审核id")
	private String moveId;
	@ApiModelProperty(value = "借调申请审核Id")
	private String loanId;
	@ApiModelProperty(value = "base64文件流")
	private String content;
}

